"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } } function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }

var _chunkIIGBXBL6cjs = require('./chunk-IIGBXBL6.cjs');


var _chunkQT3OZZO4cjs = require('./chunk-QT3OZZO4.cjs');



var _chunkRLHQ6YHCcjs = require('./chunk-RLHQ6YHC.cjs');




var _chunkDRU33ZUGcjs = require('./chunk-DRU33ZUG.cjs');



var _chunkBXM45HLQcjs = require('./chunk-BXM45HLQ.cjs');

// src/common/schema/env.ts
function parseSchemaEnv(schema, env = _nullishCoalesce(_optionalChain([process, 'optionalAccess', _ => _.env]), () => ( {})), prefix = "") {
  _chunkQT3OZZO4cjs.assert.call(void 0, _chunkIIGBXBL6cjs.isSchemaObjectFlat.call(void 0, schema), "schema should be a flat object");
  const pl = prefix.length;
  if (pl > 0)
    env = _chunkRLHQ6YHCcjs.objectFilter.call(void 0, env, (key) => key.startsWith(prefix));
  env = _chunkRLHQ6YHCcjs.objectMap.call(void 0, env, (key, value) => {
    if (pl > 0)
      key = key.substring(pl);
    return [_chunkBXM45HLQcjs.toCamelCase.call(void 0, key), value];
  });
  return _chunkRLHQ6YHCcjs.objectMap.call(void 0, schema._object, (key, schema2) => {
    let value = env[_chunkBXM45HLQcjs.toCamelCase.call(void 0, key)];
    if (schema2.type === "number") {
      value = _chunkDRU33ZUGcjs.valueToInteger.call(void 0, value, schema2._default);
    } else if (schema2.type === "boolean") {
      if (schema2._default === true)
        value = _chunkDRU33ZUGcjs.valueToBooleanNotFalse.call(void 0, value);
      else
        value = _chunkDRU33ZUGcjs.valueToBoolean.call(void 0, value, false);
    }
    return schema2.parse(value);
  });
}
function stringFromSchemaEnv(schema, prefix = "", commentOut = false) {
  _chunkQT3OZZO4cjs.assert.call(void 0, _chunkIIGBXBL6cjs.isSchemaObjectFlat.call(void 0, schema), "schema should be a flat object");
  const lines = [];
  _chunkRLHQ6YHCcjs.objectMap.call(void 0, schema._object, (key, schema2) => {
    lines.push(`${commentOut ? "# " : ""}${prefix + _chunkBXM45HLQcjs.fromCamelCase.call(void 0, key, "_").toUpperCase()}=${_nullishCoalesce(schema2._default, () => ( ""))}`);
  });
  return lines.join("\n");
}




exports.parseSchemaEnv = parseSchemaEnv; exports.stringFromSchemaEnv = stringFromSchemaEnv;
//# sourceMappingURL=chunk-K7QMHXIF.cjs.map